catalog/urls.py
from django.urls import path

from . import views

app_name = 'catalog'

urlpatterns = [
    path('catalog', views.catalog, name='catalog'),
    path('catalogdata', views.catalog_json)
]

gabriel_website_3/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('my_profile.urls')),
    path('', include('catalog.urls')),
    path('', include('users.urls'))
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('add_kegiatan', views.add_kegiatan, name='add_kegiatan'),
    path('ikut_kegiatan/<int:id>', views.ikut_kegiatan)
]

my_profile/urls.py
from django.urls import path

from . import views

app_name = 'my_profile'

urlpatterns = [
    path('profile', views.profile, name='profile')
]

users/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views

from . import views

app_name = 'users'

urlpatterns = [
    path('register', views.register, name='register'),
    path('login', views.login_view, name='login'),
    path('logout', views.logout_view, name='logout')
]

catalog/models.py
from django.db import models

# Create your models here.

main/models.py
from django.db import models

# Create your models here.
class Kegiatan(models.Model):
    nama = models.CharField(max_length=20)
    peserta = models.ManyToManyField("Peserta", related_name="kegiatans")

class Peserta(models.Model):
    nama = models.CharField(max_length=20)

my_profile/models.py
from django.db import models

# Create your models here.

users/models.py
from django.db import models

# Create your models here.

main/forms.py
from django import forms
from .models import Kegiatan, Peserta

class JoinKegiatanForm(forms.ModelForm):
    class Meta:
        model = Peserta
        fields = ["nama"]
    
    attributes = {
        "class" : "form-control",
        "placeholder" : "Nama kamu"
    }
    
    nama = forms.CharField(label="", required=True, widget=forms.TextInput(attrs=attributes))

class AddKegiatanForm(forms.ModelForm):
    class Meta:
        model = Kegiatan
        fields = ["nama"]
    
    attributes = {
        "class" : "form-control",
        "placeholder" : "Nama kegiatan"
    }

    nama = forms.CharField(label="", required=True, widget=forms.TextInput(attrs=attributes))
    

users/forms.py
from django import forms
from django.contrib.auth.models import User
from django.contrib.auth.forms import UserCreationForm

class RegistrationForm(UserCreationForm):
    email = forms.EmailField()

    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']

catalog/views.py
from django.shortcuts import render
from django.http import JsonResponse

import json
import random
import requests

def generate_placeholder():
    placeholders = [
        "Mau cari buku apa?",
        "Buku adalah jendela dunia...",
        "Cari buku yuk...",
        "Sudah baca buku hari ini?"
    ]
    return random.choice(placeholders)

def catalog(request):
    context = {
        'placeholder': generate_placeholder()
    }
    return render(request, "catalog/catalog.html", context)

def catalog_json(request):
    url = "https://www.googleapis.com/books/v1/volumes?q=" + request.GET['q']
    api_response = requests.get(url)
    api_data = json.loads(api_response.content)
    return JsonResponse(api_data, safe=False) 

main/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from .models import Kegiatan, Peserta
from .forms import AddKegiatanForm, JoinKegiatanForm

def home(request):
    response = {
        "kegiatans" : Kegiatan.objects.all()
    }
    
    return render(request, "main/home.html", response)


def add_kegiatan(request):
    response = {
        "form" : AddKegiatanForm,
        "prompt" : ""
    }

    if request.method == "POST":
        form = AddKegiatanForm(request.POST or None)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect("/")
        else:
            response["prompt"] = "Maksimal 20 karakter"
            return render(request, 'main/add.html', response)

    return render(request, "main/add.html", response)


def ikut_kegiatan(request, id):
    response = {
        "nama_kegiatan" : Kegiatan.objects.get(id=id).nama,
        "form" : JoinKegiatanForm,
        "prompt" : ""
    }

    if request.method == "POST":
        form = JoinKegiatanForm(request.POST or None)
        if form.is_valid():
            peserta = form.save(commit=False)
            peserta.save()
            kegiatan = Kegiatan.objects.get(id=id)
            kegiatan.peserta.add(peserta)
            return HttpResponseRedirect("/")
        else:
            response["prompt"] = "Maksimal 20 karakter"
            return render(request, 'main/join.html', response)

    return render(request, 'main/join.html', response)
    

my_profile/views.py
from django.shortcuts import render

def profile(request):
    context = {}
    return render(request, "my_profile/profile.html", context)
    

users/views.py
from django.contrib import messages
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.forms import AuthenticationForm
from django.http import HttpResponseRedirect
from django.shortcuts import render
from .forms import RegistrationForm

def register(request):
    if request.user.is_authenticated:
        messages.warning(request, "You already have an account!")
        return HttpResponseRedirect('/')
    else:
        context = {}
        
        if request.method == "POST":
            form = RegistrationForm(request.POST)
            if form.is_valid():
                form.save()
                messages.success(request, 'Your account was successfully created! You can login now')
                return HttpResponseRedirect('/login')
        else:
            form = RegistrationForm()

        context['form'] = form
        return render(request, 'users/register.html', context)

def login_view(request):
    if request.user.is_authenticated:
        messages.warning(request, "You're already logged in!")
        return HttpResponseRedirect('/')
    else:
        context = {}

        if request.method == "POST":
            form = AuthenticationForm(data=request.POST)
            if form.is_valid():
                username = form.cleaned_data['username']
                password = form.cleaned_data['password']
                user = authenticate(request, username=username, password=password)
                if user is not None:
                    login(request, user)
                    messages.success(request, f'Successfully logged in as <b>{username}</b>!', extra_tags='safe')
                    return HttpResponseRedirect('/')
        else:
            form = AuthenticationForm()

        context['form'] = form
        return render(request, 'users/login.html', context)

def logout_view(request):
    if request.user.is_authenticated:
        logout(request)
        messages.success(request, 'Successfully logged out!')
    else:
        messages.warning(request, 'You need to <a href="login" class="alert-link">login</a> in order to logout!', extra_tags='safe')
    
    return HttpResponseRedirect('/login')

catalog/templates/catalog/catalog.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>CatalogKu</title>
{% endblock meta %}

{% block scripts %}
<script src="{% static 'scripts/book.js' %}" type="text/javascript"></script>
{% endblock scripts %}

{% block content %}
<!-- Catalog page title -->
<div class="container-fluid padding">
    <div class="row text-center m-3">
        <div class="col-12">
            <h1 class="display-4">CatalogKu</h1>
        </div>
    </div>
</div>

<!-- Messages prompt -->
{% include 'messages.html' %}

<!-- User query field -->
<div class="container-fluid padding">
    <div class="row center m-3">
        <input id="user-query" class="form-control col-12" type="text" placeholder="{{ placeholder }}">
    </div>
</div>

<!-- Book display catalog -->
<div class="container-fluid padding">
    <div id="display-catalog" class="book-display-catalog card-columns">

    </div>
</div>
{% endblock content %}

main/templates/main/add.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>KegiatanKu - Add</title>
{% endblock meta %}

{% block content %}
<div class="container-fluid padding">
    <div class="row text-center m-3">
        <div class="col-12">
            <h2 class="m-3">Add Kegiatan</h2>
        </div>
    </div>

    <div class="row cemter m-3">
        <div class="col-md-12">
            <div class="form-group">
                <form action="" method="POST">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <input class="btn btn-success" type="submit" value="Tambahkan"> 
                    <a class="btn btn-outline-danger" href="{% url 'main:home' %}">Back</a>
                    <small class="error-prompt"><b>{{ prompt }}</b></small>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

main/templates/main/home.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>KegiatanKu</title>
{% endblock meta %}

{% block content %}
<!-- Home page title -->
<div class="container-fluid padding">
<div class="row text-center m-3">
    <div class="col-12">
        <h1 class="display-4">KegiatanKu</h1>
    </div>
</div>
</div>

<!-- Messages prompt -->
{% include 'messages.html' %}

<!-- Add kegiatan button -->
<div class="container-fluid padding">
<div class="row text-center m-3">
    <div class="col-12">
        <a class="btn btn-primary" href="{% url 'main:add_kegiatan' %}">Add Kegiatan</a>
    </div>
</div>
</div>

<!-- Kegiatan cards -->
{% if kegiatans %}
<div class="container-fluid padding">
    <div class="kegiatan-display card-columns">
        {% for kegiatan in kegiatans %}
            <div class="card">
                <div class="card-body">                
                    <h4 class="card-title">{{ kegiatan.nama }}</h4>
                    {% if kegiatan.peserta.all %}
                        <ul class="list-group list-group-flush">
                            {% for peserta in kegiatan.peserta.all %}
                                <li class="list-group-item">{{ peserta.nama }}</li>
                            {% endfor %}
                        </ul>
                    {% endif %}
                    <a class="btn btn-secondary join-button" href="/ikut_kegiatan/{{ kegiatan.id }}">Mau Ikut</a>
                </div>
            </div>
        {% endfor %}
    </div>
</div>

{% elif not kegiatans %}
<!-- No kegiatan prompt -->
<div class="container-fluid padding">
<div class="row text-center m-3">
    <div class="col-12">
        <h2 class="m-3">Belum ada Kegiatan</h2>
    </div>
</div>
</div>

{% endif %}
{% endblock content %}

main/templates/main/join.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>KegiatanKu - Join</title>
{% endblock meta %}

{% block content %}
<div class="container-fluid padding">
    <div class="row text-center m-3">
        <div class="col-12">
            <h2 class="m-3">{{ nama_kegiatan }}</h2>
        </div>
    </div>

    <div class="row cemter m-3">
        <div class="col-md-12">
            <div class="form-group">
                <form action="" method="POST">
                    {% csrf_token %}
                    {{ form.as_p }}
                    <input class="btn btn-success" type="submit" value="Sign me up"> 
                    <a class="btn btn-outline-danger" href="{% url 'main:home' %}">Back</a>
                    <small class="error-prompt"><b>{{ prompt }}</b></small>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

my_profile/templates/my_profile/profile.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>ProfileKu</title>
{% endblock meta %}

{% block scripts %}
<script src="{% static 'scripts/accordion.js' %}" type="text/javascript"></script>
{% endblock scripts %}

{% block content %}
<!-- Profile page title -->
<div class="container-fluid padding">
<div class="row text-center m-3">
    <div class="col-12">
        <h1 class="display-4">ProfileKu</h1>
    </div>
</div>
</div>

<!-- Messages prompt -->
{% include 'messages.html' %}

<!-- Main accordion -->
<div class="container-fluid padding">
    <div class="accordion d-flex flex-column">
        <div class="accordion-section padding pb-3 order-1">
            <div class="accordion-header row">
                <div class="header-text col-10 h3">Aktivitas</div>
                <div class="move-up col-1 text-center"><i class="fa fa-angle-up"></i></div>
                <div class="move-down col-1 text-center"><i class="fa fa-angle-down"></i></div>
            </div>
            <div class="accordion-content padding p-3 active">
                Aktivitas saya belakangan ini hanya kuliah, kuliah, kuiliah dan... kuliah. Setelah UTS entah kenapa ada rasa-rasa bisa bersantai, tetapi masuk minggu ke-2 pasca UTS, sudah tidak bisa rebahan di kasur lagi. Main game juga harus hati-hati karena kalau sudah main bisa-bisa bablas dan lupa mengerjakan tugas (<em>learned it the hard way</em>).
            </div>
        </div>

        <div class="accordion-section padding pb-3 order-2">
            <div class="accordion-header row">
                <div class="header-text col-10 h3">Pengalaman</div>
                <div class="move-up col-1 text-center"><i class="fa fa-angle-up"></i></div>
                <div class="move-down col-1 text-center"><i class="fa fa-angle-down"></i></div>
            </div>
            <div class="accordion-content padding p-3">
                Sejauh ini pengalaman saya masih belum banyak. Masih koding sana-sini. Stackoverflow ini stackoverflow itu. Tetapi perlahan tapi pasti sepertinya pengalaman saya mulai terkumpul. Sejauh ini saya setiap semester masih mengikuti kegiatan-kegiatan non-akademis sehingga masih seimbang. Sebagai formalitas (karena harus ada pengalaman) saya semester ini bergabung ke dalam staf dokum PMB 2020.
            </div>
        </div>
        
        <div class="accordion-section padding pb-3 order-3">
            <div class="accordion-header row">
                <div class="header-text col-10 h3">Prestasi</div>
                <div class="move-up col-1 text-center"><i class="fa fa-angle-up"></i></div>
                <div class="move-down col-1 text-center"><i class="fa fa-angle-down"></i></div>
            </div>
            <div class="accordion-content padding p-3">
                Prestasi... :)
                <br>
                Ya saat ini sepertinya belum ada. Tetapi saya pasti akan terus mencoba untuk meraih banyak prestasi agar bisa berguna bagi banyak orang.
            </div>
        </div>

        <div class="accordion-section padding pb-3 order-4">
            <div class="accordion-header row">
                <div class="header-text col-10 h3">Lainnya</div>
                <div class="move-up col-1 text-center"><i class="fa fa-angle-up"></i></div>
                <div class="move-down col-1 text-center"><i class="fa fa-angle-down"></i></div>
            </div>
            <div class="accordion-content padding p-3">
                Ini adalah konten terakhir. Saya tidak tahu mau diisi apa, karena mengisi konten yang atas saja sudah bingung, padahal tipe kontennya sudah ditentukan; apa lagi ini :)
                <br>
                Ya begitulah... Sekian dari saya, terima kasih sudah klik-klik akordionnya. Akordionnya tidak bisa bersuara. Karena nyanyian merdu akordionnya sudah saya habiskan saat ngoding web ini; nyanyian-nyanyian kesengsaraan karena ini akrodion layoutingnya susah banget CSS-nya :)
            </div>
        </div>
    </div>
</div>
{% endblock content %}

templates/base.html
{% load static %}
<!DOCTYPE html>

<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <!-- Font Awesome -->
        <link rel="stylesheet" type="text/css" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">

        <!-- JQuery -->
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>

        <!-- Bootstrap -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
        
        <!-- Styles -->
        <link rel="stylesheet" href="{% static 'css/style.css' %}">

        <!-- Icon -->
        <link rel="icon" href="{% static 'img/webicon.ico' %}" type="image/x-icon">

        {% block meta %}
        {% endblock meta %}

        {% block scripts %}
        {% endblock scripts %}
    </head>

    <body>
        <!-- Navbar -->
        <nav class="navbar navbar-expand-lg navbar-light bg-light">
            <a class="navbar-brand" href="/">WebsiteKu</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
          
            <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
                <!-- Left Side Navbar -->
                <ul class="navbar-nav mr-auto mt-2 mt-lg-0">
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'main:home' %}">KegiatanKu</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'my_profile:profile' %}">ProfileKu</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'catalog:catalog' %}">CatalogKu</a>
                    </li>
                </ul>

                <!-- Right Side Navbar -->
                <form class="form-inline my-2 my-lg-0">
                    <ul class="navbar-nav mr-auto mt-2 mt-lg-0">
                        {% if user.is_authenticated %}
                            <span class="navbar-text mr-1">
                                Hi, <b>{{ user.username }}</b>
                            </span>
                            <li class="nav-item ml-2">
                                <a class="btn btn-outline-secondary" href="{% url 'users:logout' %}">Logout</a>
                            </li>
                        {% else %}
                            <li class="nav-item">
                                <a class="nav-link" href="{% url 'users:login' %}">Sign In</a>
                            </li>
                            <li class="nav-item ml-1">
                                <a class="btn btn-outline-secondary" href="{% url 'users:register' %}">Sign Up</a>
                            </li>
                        {% endif %}
                    </ul>
                </form>
            </div>
        </nav>

        {% block content %}
        {% endblock content %}
    </body>
</html>

templates/messages.html
{% if messages %}
    {% for message in messages %}
        <div class="container-fluid padding">
            <div class="row m-1">
                <div class="col-12">
                    {% if 'success' in message.tags %}
                        <div class="alert alert-success">
                            {% if 'safe' in message.tags %}
                                {{ message|safe }}
                            {% else %}
                                {{ message }}
                            {% endif %}
                        </div>
                    {% elif 'error' in message.tags %}
                        <div class="alert alert-danger">
                            {% if 'safe' in message.tags %}
                                {{ message|safe }}
                            {% else %}
                                {{ message }}
                            {% endif %}
                        </div>
                    {% elif 'warning' in message.tags %}
                        <div class="alert alert-warning">
                            {% if 'safe' in message.tags %}
                                {{ message|safe }}
                            {% else %}
                                {{ message }}
                            {% endif %}
                        </div>
                    {% endif %}
                </div>
            </div>
        </div>
    {% endfor %}
{% endif %}

users/templates/users/login.html
{% extends 'base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block meta %}
<title>Sign In</title>
{% endblock meta %}

{% block scripts %}
{% endblock scripts %}

{% block content %}
<!-- Login page title -->
<div class="container-fluid padding">
    <div class="row text-center m-3">
        <div class="col-12">
            <h1 class="display-4">Sign In</h1>
        </div>
    </div>
</div>

<!-- Messages prompt -->
{% include 'messages.html' %}

<!-- Login Form -->
<div class="container-fluid padding">
    <div class="row m-3">
        <div class="col-12">
            <div class="form-group">
                <form method="POST"> {% csrf_token %}
                    {{ form|crispy }}
                    <button class="btn btn-success" type="submit">Login</button>
                    <small class="text-muted pl-1">
                        Don't Have An Account? <a href="{% url 'users:register' %}">Sign Up</a>
                    </small>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

users/templates/users/register.html
{% extends 'base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block meta %}
<title>Sign Up</title>
{% endblock meta %}

{% block scripts %}
{% endblock scripts %}

{% block content %}
<!-- Register page title -->
<div class="container-fluid padding">
    <div class="row text-center m-3">
        <div class="col-12">
            <h1 class="display-4">Sign Up</h1>
        </div>
    </div>
</div>

<!-- Registration Form -->
<div class="container-fluid padding">
    <div class="row m-3">
        <div class="col-12">
            <div class="form-group">
                <form method="POST"> {% csrf_token %}
                    {{ form|crispy }}
                    <button class="btn btn-success" type="submit">Sign Up</button>
                    <small class="text-muted pl-1">
                        Have An Account Already? <a href="{% url 'users:login' %}">Sign In</a>
                    </small>
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock content %}